package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[TSSDTaskType] 数据对象
 */
@TableName(value = "T_SRFTSSDTASKTYPE",resultMap = "TSSDTaskTypeResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class TSSDTaskType extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    private String taskobject;
    private String tasktypeparam;
    @TableId(value= "tssdtasktypeid",type=IdType.UUID)//指定主键生成策略
    private String tssdtasktypeid;
    private String tssdtasktypename;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[任务对象]
     *  @param taskobject
     */
    public void setTaskobject(String taskobject){
        if(StringUtils.isEmpty(taskobject))
            taskobject=null;
        this.taskobject = taskobject;
        this.set("taskobjectdirtyflag",true);
    }
    /**
     *  获取属性值[任务对象]
     */
    public String getTaskobject(){
        return this.taskobject;
    }
    /**
     *  重置属性值[任务对象]
     */
    public void resetTaskobject(){
        this.set("taskobjectdirtyflag",false);
        this.taskobject = null;
    }
    /**
     *  设置属性值[任务类型参数]
     *  @param tasktypeparam
     */
    public void setTasktypeparam(String tasktypeparam){
        if(StringUtils.isEmpty(tasktypeparam))
            tasktypeparam=null;
        this.tasktypeparam = tasktypeparam;
        this.set("tasktypeparamdirtyflag",true);
    }
    /**
     *  获取属性值[任务类型参数]
     */
    public String getTasktypeparam(){
        return this.tasktypeparam;
    }
    /**
     *  重置属性值[任务类型参数]
     */
    public void resetTasktypeparam(){
        this.set("tasktypeparamdirtyflag",false);
        this.tasktypeparam = null;
    }
    /**
     *  设置属性值[任务调度任务类型标识]
     *  @param tssdtasktypeid
     */
    public void setTssdtasktypeid(String tssdtasktypeid){
        if(StringUtils.isEmpty(tssdtasktypeid))
            tssdtasktypeid=null;
        this.tssdtasktypeid = tssdtasktypeid;
        this.set("tssdtasktypeiddirtyflag",true);
    }
    /**
     *  获取属性值[任务调度任务类型标识]
     */
    public String getTssdtasktypeid(){
        return this.tssdtasktypeid;
    }
    /**
     *  重置属性值[任务调度任务类型标识]
     */
    public void resetTssdtasktypeid(){
        this.set("tssdtasktypeiddirtyflag",false);
        this.tssdtasktypeid = null;
    }
    /**
     *  设置属性值[任务类型名称]
     *  @param tssdtasktypename
     */
    public void setTssdtasktypename(String tssdtasktypename){
        if(StringUtils.isEmpty(tssdtasktypename))
            tssdtasktypename=null;
        this.tssdtasktypename = tssdtasktypename;
        this.set("tssdtasktypenamedirtyflag",true);
    }
    /**
     *  获取属性值[任务类型名称]
     */
    public String getTssdtasktypename(){
        return this.tssdtasktypename;
    }
    /**
     *  重置属性值[任务类型名称]
     */
    public void resetTssdtasktypename(){
        this.set("tssdtasktypenamedirtyflag",false);
        this.tssdtasktypename = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetTaskobject();
        resetTasktypeparam();
        resetTssdtasktypeid();
        resetTssdtasktypename();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public TSSDTaskType copyTo(TSSDTaskType targetEntity)
	{
		BeanCopier copier=BeanCopier.create(TSSDTaskType.class, TSSDTaskType.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetTssdtasktypeid();
		return targetEntity;
	}
}